Bug 1515748 - Callbacks should be sent to only those clients which register for upcall events
Summary: Callbacks should be sent to only those clients which register for upcall events
Keywords:
Status: CLOSED DEFERRED
Alias: None
Product: GlusterFS
Classification: Community
Component: upcall
Version: mainline
Hardware: All
OS: All
medium
medium
Target Milestone: ---
Assignee: bugs@gluster.org
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-11-21 10:00 UTC by Soumya Koduri
Modified: 2019-06-20 08:52 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-06-20 08:52:48 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:


Attachments (Terms of Use)

Description Soumya Koduri 2017-11-21 10:00:26 UTC
Description of problem:

Currently, the callbacks, when generated, are sent to all the clients irrespective of whether they are interested or not. This needs to be addressed. 

We can make use of IPC fop to notify upcall xlator whenever an application/clients starts polling or registers for upcall events.


Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Comment 1 Worker Ant 2017-11-27 11:27:05 UTC
REVIEW: https://review.gluster.org/18863 (IPC: Add new IPC op to register/unregister upcall) posted (#1) for review on master by soumya k

Comment 2 Worker Ant 2017-11-27 11:27:55 UTC
REVIEW: https://review.gluster.org/18864 (md-cache: Use new IPC op to register/unreigster upcall) posted (#1) for review on master by soumya k

Comment 3 Worker Ant 2017-11-27 11:28:56 UTC
REVIEW: https://review.gluster.org/18866 (Upcall: Allow clients to register for cache-invalidation event) posted (#1) for review on master by soumya k

Comment 4 Worker Ant 2017-11-27 11:29:30 UTC
REVIEW: https://review.gluster.org/18865 (gfapi: Use new IPC op to register/unregister upcall event) posted (#1) for review on master by soumya k

Comment 5 Amar Tumballi 2019-06-20 04:47:33 UTC
Soumya, do you think we can close this? I see that these patches are not merged :-/ What should be our next step?

Comment 6 Soumya Koduri 2019-06-20 08:49:19 UTC
(In reply to Amar Tumballi from comment #5)
> Soumya, do you think we can close this? I see that these patches are not
> merged :-/ What should be our next step?

It will be good enhancement. This needs to be handled at different layers which I had posted patches for (IPC, md-cache, Upcall and gfapi). gfapi changes are addressed via a different patch - https://review.gluster.org/#/c/glusterfs/+/18349/ . Other patches (mostly trivial) can be revived and modified as per comments.

If there is anyone who is willing to take it forward I will be happy to guide. Or else it may take a little more while for me to work on this. We can close this bug and I will re-open incase I plan to fix it in future.

Comment 7 Amar Tumballi 2019-06-20 08:52:48 UTC
Thanks for the update Soumya. Will mark it as DEFERRED, and we can pick up when we get a chance.


Note You need to log in before you can comment on or make changes to this bug.